## organicmaps 2026.01.26

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22.1)

project(omim C CXX)

set(CMAKE_CXX_STANDARD 23)
set(CMAKE_C_STANDARD 17)
# Our code does not rely on gnu extensions.
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_EXTENSIONS OFF)

set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

# Fixes warning ld: warning: ignoring duplicate libraries on Mac and Windows.
if (POLICY CMP0156)
  cmake_policy(SET CMP0156 NEW)
endif()

set(OMIM_ROOT ${CMAKE_SOURCE_DIR})
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${OMIM_ROOT}/cmake")

set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

include(OmimPlatform)
include(OmimOptions)
include(OmimConfig)
include(OmimHelpers)
include(OmimTesting)

if (APPLE AND NOT ("${CMAKE_SYSTEM_NAME}" STREQUAL Android))
  # OBJC/OBJCXX are needed to skip m/mm files in Unity builds.
  # https://gitlab.kitware.com/cmake/cmake/-/issues/21963
  enable_language(OBJC)
  set(CMAKE_OBJC_EXTENSIONS OFF)
  set(CMAKE_OBJC_STANDARD 23)
  set(CMAKE_OBJC_FLAGS -fobjc-arc)
  set(CMAKE_OBJC_VISIBILITY_PRESET hidden)
  enable_language(OBJCXX)
  set(CMAKE_OBJCXX_EXTENSIONS OFF)
  set(CMAKE_OBJCXX_STANDARD 23)
  set(CMAKE_OBJCXX_FLAGS -fobjc-arc)
  set(CMAKE_OBJCXX_VISIBILITY_PRESET hidden)
endif()

message(STATUS "Using compiler ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}")

if (CMAKE_UNITY_BUILD)
  message(STATUS "Using Unity Build with batch ${CMAKE_UNITY_BUILD_BATCH_SIZE}, use -DCMAKE_UNITY_BUILD=OFF to disable it.")
endif()

if (USE_CCACHE)
  find_program(CCACHE_PROGRAM ccache HINTS /usr/local/bin/)
  if (CCACHE_PROGRAM)
    message(STATUS "Using ccache, use -DUSE_CCACHE=OFF to disable it.")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CCACHE_PROGRAM}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK "${CCACHE_PROGRAM}")
    set(CMAKE_C_COMPILER_LAUNCHER   "${CCACHE_PROGRAM}")
    set(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_PROGRAM}")
  endif()
endif()

if(${PLATFORM_MAC})
  set(XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC YES)

  # Metal language support
  list(APPEND CMAKE_MODULE_PATH ${OMIM_ROOT}/3party/CMake-MetalShaderSupport/cmake)
  include(CheckLanguage)
  include(CMakeMetalInformation)
  include(MetalShaderSupport)
  check_language(Metal)
  if(CMAKE_Metal_COMPILER)
    enable_language(Metal)
  endif()
endif()

# Global compile options for all configurations.
if (MSVC)
  add_compile_options(/utf-8)
  add_link_options(/INCREMENTAL:NO)
else()
  add_compile_options(-ffast-math $<$<CXX_COMPILER_ID:GNU>:-Wno-psabi>)
endif()

if (PLATFORM_WIN)
  add_definitions(
    -DWIN32_LEAN_AND_MEAN
    -DNOMINMAX
  )
endif()

# Built-in CMake configurations: Debug, Release, RelWithDebInfo, MinSizeRel
if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
  add_definitions(-DDEBUG)
  if (NOT MSVC)
    add_compile_options(-fno-omit-frame-pointer)
  endif()
elseif (${CMAKE_BUILD_TYPE} MATCHES "Rel")
  add_definitions(-DRELEASE)
  if (NOT MSVC)
    add_compile_options(-O3)
  endif()
else()
  message(FATAL_ERROR "Unknown build type: " ${CMAKE_BUILD_TYPE})
endif()

message(STATUS "Build type: " ${CMAKE_BUILD_TYPE})

if (PLATFORM_LINUX OR PLATFORM_ANDROID)
  find_program(LLD_FOUND ld.lld)
  if (LLD_FOUND)
    message(STATUS "Using ld.lld linker")
    set(CMAKE_EXE_LINKER_FLAGS "-fuse-ld=lld")
  else()
    find_program(GOLD_FOUND ld.gold)
    if (GOLD_FOUND)
      message(STATUS "Using ld.gold")
      set(CMAKE_EXE_LINKER_FLAGS "-fuse-ld=gold")
    endif()
  endif()
endif()

if (NOT SKIP_TESTS)
  enable_testing()
  # Enables ctest -T memcheck with valgrind
  include(CTest)
  if (COVERAGE_REPORT)
    include(OmimCoverage)
  endif ()
endif()

if (NOT PYTHON_VERSION)
  # FDroid build server has 3.5.3 Python installed.
  set(PYTHON_VERSION 3.5)
endif()

# End of setting environment variables

find_package(Threads REQUIRED)

# Scripts

if (NOT PLATFORM_IPHONE AND NOT PLATFORM_ANDROID)
  list(APPEND qt_components Core Network)
  if (NOT SKIP_QT_GUI OR NOT SKIP_TESTS OR PYBINDINGS)
    list(APPEND qt_components Widgets)
  endif()
  if (NOT SKIP_QT_GUI)
    list(APPEND qt_components Gui Xml Svg OpenGL OpenGLWidgets)
  endif()
  # PATHS are hard-coded hints where to look for qt6 in addition to other places.
  find_package(Qt6 COMPONENTS REQUIRED ${qt_components} OPTIONAL_COMPONENTS Positioning PATHS $ENV{QT_PATH} /opt/homebrew/opt/qt@6 /usr/local/opt/qt@6 /usr/lib/x86_64-linux-gnu/qt6)

  set(MINIMUM_REQUIRED_QT_VERSION 6.4.0)
  if (Qt6Widgets_VERSION VERSION_LESS ${MINIMUM_REQUIRED_QT_VERSION})
    message(FATAL_ERROR "Unsupported Qt version: ${Qt6Widgets_VERSION}, the minimum required is ${MINIMUM_REQUIRED_QT_VERSION}")
  else()
    message(STATUS "Found Qt version: ${Qt6Widgets_VERSION}")
  endif()
endif()

# To allow #include "base/file_name.hpp" in all sources.
include_directories("${CMAKE_HOME_DIRECTORY}" "${CMAKE_HOME_DIRECTORY}/libs" "${CMAKE_HOME_DIRECTORY}/tools")

if (USE_PCH)
  message(STATUS "Precompiled headers are ON")
  set(OMIM_PCH_TARGET_NAME "omim_pch")
  add_precompiled_headers(
    ${OMIM_ROOT}/precompiled_headers.hpp
    ${OMIM_PCH_TARGET_NAME}
  )
endif()

# Should be on the root level, not in 3party, so tests can get these dependencies.
if (PLATFORM_LINUX)
  find_package(ICU COMPONENTS uc i18n data REQUIRED)
  find_package(Freetype REQUIRED)
  find_package(harfbuzz REQUIRED)
endif()

if (WITH_SYSTEM_PROVIDED_3PARTY)
  set(GFLAGS_USE_TARGET_NAMESPACE ON)
  find_package(gflags REQUIRED)

  find_package(expat CONFIG REQUIRED)
  find_package(jansson CONFIG REQUIRED)
  find_package(pugixml REQUIRED)
  find_package(utf8cpp REQUIRED)
endif()

find_package(ZLIB REQUIRED)

# Include 3party dependencies.
add_subdirectory(3party)

# Not needed for the usual build process, but it fixes QtCreator editor,
# that doesn't see gflags/gflags.h in binary dir (gflags has tricky cmake configuration).
if (PLATFORM_DESKTOP AND NOT WITH_SYSTEM_PROVIDED_3PARTY)
  include_directories("${PROJECT_BINARY_DIR}/3party/gflags/include")
endif()

# Used in qt/ and shaders/
find_package(Python3 REQUIRED COMPONENTS Interpreter)

add_subdirectory(libs)

if (PLATFORM_DESKTOP)
  add_subdirectory(dev_sandbox)
  add_subdirectory(generator)
  add_subdirectory(tools)
  if (NOT SKIP_QT_GUI)
    add_subdirectory(qt)
  endif()
endif()

omim_add_test_subdirectory(libs/qt_tstfrm)

if (PLATFORM_ANDROID)
  add_subdirectory(android/sdk/src/main/cpp)
endif()

=== 3party/CMakeLists.txt ===
# Fixes CMake deprecation warning:
# Compatibility with CMake < 3.5 will be removed from a future version of CMake.
set(CMAKE_WARN_DEPRECATED OFF CACHE BOOL "" FORCE)

if (NOT WITH_SYSTEM_PROVIDED_3PARTY)
  # Suppress "Policy CMP0077 is not set: option() honors normal variables"
  # for the freetype, expat and jansson options.
  set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)
  # Suppress "Policy CMP0063 is not set: Honor visibility properties for all target types."
  # for jansson
  set(CMAKE_POLICY_DEFAULT_CMP0063 NEW)

  add_library(Boost_headers INTERFACE)
  add_library(Boost::headers ALIAS Boost_headers)
  target_include_directories(Boost_headers SYSTEM INTERFACE "${OMIM_ROOT}/3party/boost")

  # Configure expat library.
  set(EXPAT_BUILD_TOOLS OFF)
  set(EXPAT_BUILD_EXAMPLES OFF)
  set(EXPAT_BUILD_TESTS OFF)
  set(EXPAT_BUILD_DOCS OFF)
  set(EXPAT_BUILD_PKGCONFIG OFF)
  set(EXPAT_ENABLE_INSTALL OFF)
  set(EXPAT_SHARED_LIBS OFF)
  set(EXPAT_GE OFF)
  set(EXPAT_DTD OFF)
  set(EXPAT_NS ON)
  add_subdirectory(expat/expat)

  # Configure Jansson library.
  set(JANSSON_BUILD_DOCS OFF)
  set(JANSSON_BUILD_MAN OFF)
  set(JANSSON_EXAMPLES OFF)
  set(JANSSON_INSTALL OFF)
  set(JANSSON_WITHOUT_TESTS ON)
  add_subdirectory(jansson/jansson/)
  target_include_directories(jansson INTERFACE "${PROJECT_BINARY_DIR}/3party/jansson/jansson/include")

  # Add gflags library.
  set(GFLAGS_BUILD_TESTING OFF)
  set(GFLAGS_BUILD_PACKAGING OFF)
  add_subdirectory(gflags)
  target_compile_options(gflags_nothreads_static PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wno-subobject-linkage>)

  # Add pugixml library.
  add_subdirectory(pugixml)

  # Add protobuf library.
  add_subdirectory(protobuf)

  if (NOT PLATFORM_LINUX)
    add_subdirectory(freetype)
    add_subdirectory(icu)
    add_subdirectory(harfbuzz)
  endif()

  add_library(utf8cpp INTERFACE)
  add_library(utf8cpp::utf8cpp ALIAS utf8cpp)
  target_include_directories(utf8cpp INTERFACE "${OMIM_ROOT}/3party/utfcpp/source")
endif()

add_subdirectory(agg)
add_subdirectory(bsdiff-courgette)
add_subdirectory(glaze)
add_subdirectory(minizip)
add_subdirectory(open-location-code)
add_subdirectory(opening_hours)
add_subdirectory(stb_image)
add_subdirectory(succinct)

add_subdirectory(vulkan_wrapper)

if (PLATFORM_DESKTOP)
  add_subdirectory(libtess2)

  set(GLFW_BUILD_DOCS OFF CACHE BOOL "")
  set(GLFW_BUILD_EXAMPLES OFF CACHE BOOL "")
  set(GLFW_BUILD_TESTS OFF CACHE BOOL "")
  set(GLFW_INSTALL OFF CACHE BOOL "")
  set(GLFW_VULKAN_STATIC OFF CACHE BOOL "")
  set(GLFW_BUILD_WAYLAND OFF CACHE BOOL "")
  # Disable ARC for glfw and re-enable after it because it's globally set in the root CMakeLists.txt
  set(CMAKE_OBJC_FLAGS "")
  add_subdirectory(glfw)
  set_target_properties(glfw PROPERTIES UNITY_BUILD OFF)
  set_target_properties(glfw PROPERTIES XCODE_ATTRIBUTE_CLANG_ENABLE_OBJC_ARC NO)
  set(CMAKE_OBJC_FLAGS -fobjc-arc)

  add_subdirectory(imgui)
endif()

=== generator/CMakeLists.txt ===
project(generator)

set(SRC
  addresses_collector.cpp
  addresses_collector.hpp
  address_enricher.cpp
  address_enricher.hpp
  affiliation.cpp
  affiliation.hpp
  altitude_generator.cpp
  altitude_generator.hpp
  borders.cpp
  borders.hpp
  boundary_postcodes_enricher.cpp
  boundary_postcodes_enricher.hpp
  brands_loader.cpp
  brands_loader.hpp
  camera_info_collector.cpp
  camera_info_collector.hpp
  cells_merger.cpp
  cells_merger.hpp
  centers_table_builder.cpp
  centers_table_builder.hpp
  check_model.cpp
  check_model.hpp
  cities_boundaries_builder.cpp
  cities_boundaries_builder.hpp
  cities_boundaries_checker.cpp
  cities_boundaries_checker.hpp
  cities_ids_builder.cpp
  cities_ids_builder.hpp
  city_roads_generator.cpp
  city_roads_generator.hpp
  cluster_finder.hpp
  coastlines_generator.cpp
  coastlines_generator.hpp
  collection_base.hpp
  collector_boundary_postcode.cpp
  collector_boundary_postcode.hpp
  collector_building_parts.cpp
  collector_building_parts.hpp
  collector_camera.cpp
  collector_camera.hpp
  collector_collection.cpp
  collector_collection.hpp
  collector_interface.hpp
  collector_mini_roundabout.cpp
  collector_mini_roundabout.hpp
  collector_routing_city_boundaries.cpp
  collector_routing_city_boundaries.hpp
  collector_tag.cpp
  collector_tag.hpp
#  complex_loader.cpp
#  complex_loader.hpp
  composite_id.cpp
  composite_id.hpp
  cross_mwm_osm_ways_collector.cpp
  cross_mwm_osm_ways_collector.hpp
  descriptions_section_builder.cpp
  descriptions_section_builder.hpp
  dumper.cpp
  dumper.hpp
  factory_utils.hpp
  feature_builder.cpp
  feature_builder.hpp
  feature_emitter_iface.hpp
  feature_generator.cpp
  feature_generator.hpp
  feature_helpers.cpp
  feature_helpers.hpp
  feature_maker.cpp
  feature_maker.hpp
  feature_maker_base.cpp
  feature_maker_base.hpp
  feature_merger.cpp
  feature_merger.hpp
  feature_processing_layers.cpp
  feature_processing_layers.hpp
  feature_sorter.cpp
  feature_sorter.hpp
  features_processing_helpers.hpp
  filter_collection.cpp
  filter_collection.hpp
#  filter_complex.cpp
#  filter_complex.hpp
  filter_elements.cpp
  filter_elements.hpp
  filter_interface.hpp
  filter_planet.cpp
  filter_planet.hpp
  filter_roads.cpp
  filter_roads.hpp
  filter_world.cpp
  filter_world.hpp
  final_processor_cities.cpp
  final_processor_cities.hpp
  final_processor_coastline.cpp
  final_processor_coastline.hpp
#  final_processor_complex.cpp
#  final_processor_complex.hpp
  final_processor_country.cpp
  final_processor_country.hpp
  final_processor_interface.hpp
  final_processor_utils.cpp
  final_processor_utils.hpp
  final_processor_world.cpp
  final_processor_world.hpp
  gen_mwm_info.cpp
  gen_mwm_info.hpp
  generate_info.hpp
  geometry_holder.hpp
#  hierarchy.cpp
#  hierarchy.hpp
#  hierarchy_entry.cpp
#  hierarchy_entry.hpp
  holes.cpp
  holes.hpp
  intermediate_data.cpp
  intermediate_data.hpp
  intermediate_elements.hpp
  isolines_generator.cpp
  isolines_generator.hpp
  isolines_section_builder.cpp
  isolines_section_builder.hpp
  maxspeeds_builder.cpp
  maxspeeds_builder.hpp
  maxspeeds_collector.cpp
  maxspeeds_collector.hpp
  maxspeeds_parser.cpp
  maxspeeds_parser.hpp
  metalines_builder.cpp
  metalines_builder.hpp
  mini_roundabout_info.cpp
  mini_roundabout_info.hpp
  mini_roundabout_transformer.cpp
  mini_roundabout_transformer.hpp
  node_mixer.cpp
  node_mixer.hpp
  osm2meta.cpp
  osm2meta.hpp
  osm2type.cpp
  osm2type.hpp
  osm_element.cpp
  osm_element.hpp
  osm_element_helpers.cpp
  osm_element_helpers.hpp
  osm_o5m_source.hpp
  osm_source.cpp
  osm_xml_source.hpp
  place_processor.cpp
  place_processor.hpp
  platform_helpers.cpp
  platform_helpers.hpp
  popular_places_section_builder.cpp
  popular_places_section_builder.hpp
  postcode_points_builder.cpp
  postcode_points_builder.hpp
  processor_coastline.cpp
  processor_coastline.hpp
#  processor_complex.cpp
#  processor_complex.hpp
  processor_country.cpp
  processor_country.hpp
  processor_factory.hpp
  processor_interface.hpp
  processor_noop.hpp
#  processor_simple.cpp
#  processor_simple.hpp
  processor_world.cpp
  processor_world.hpp
  raw_generator.cpp
  raw_generator.hpp
  raw_generator_writer.cpp
  raw_generator_writer.hpp
  region_meta.cpp
  region_meta.hpp
  relation_tags.cpp
  relation_tags.hpp
  relation_tags_enricher.cpp
  relation_tags_enricher.hpp
  restriction_collector.cpp
  restriction_collector.hpp
  restriction_generator.cpp
  restriction_generator.hpp
  restriction_writer.cpp
  restriction_writer.hpp
  road_access_generator.cpp
  road_access_generator.hpp
  routing_city_boundaries_processor.cpp
  routing_city_boundaries_processor.hpp
  routing_helpers.cpp
  routing_helpers.hpp
  routing_index_generator.cpp
  routing_index_generator.hpp
  routing_world_roads_generator.cpp
  routing_world_roads_generator.hpp
  search_index_builder.cpp
  search_index_builder.hpp
  srtm_parser.cpp
  srtm_parser.hpp
  statistics.cpp
  statistics.hpp
  tag_admixer.hpp
  tesselator.cpp
  tesselator.hpp
  towns_dumper.cpp
  towns_dumper.hpp
  traffic_generator.cpp
  traffic_generator.hpp
  transit_generator.cpp
  transit_generator.hpp
  transit_generator_experimental.cpp
  transit_generator_experimental.hpp
  translator.cpp
  translator.hpp
  translator_coastline.cpp
  translator_coastline.hpp
  translator_collection.cpp
  translator_collection.hpp
#  translator_complex.cpp
#  translator_complex.hpp
  translator_country.cpp
  translator_country.hpp
  translator_factory.hpp
  translator_interface.hpp
  translator_world.cpp
  translator_world.hpp
  translators_pool.cpp
  translators_pool.hpp
  unpack_mwm.cpp
  unpack_mwm.hpp
  utils.cpp
  utils.hpp
  ways_merger.cpp
  ways_merger.hpp
  way_nodes_mapper.hpp
  wiki_url_dumper.cpp
  wiki_url_dumper.hpp
  water_boundary_checker.hpp
  world_map_generator.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  PUBLIC
    om::timezone
    transit
    search
    routing
    storage
    descriptions
    indexer
    cppjansson
    expat::expat
    tess2
    ${CMAKE_DL_LIBS} # dladdr from boost::stacktrace
)

# Disable unity build to avoid boost::geometry macro linker errors.
set_source_files_properties(
  affiliation.cpp
  final_processor_country.cpp
  hierarchy.cpp
  PROPERTIES SKIP_UNITY_BUILD_INCLUSION TRUE
)

if (NOT (SKIP_TOOLS AND SKIP_TESTS))
  # Used in both tests and some tools.
  add_subdirectory(generator_tests_support)
endif()
omim_add_test_subdirectory(generator_tests)
omim_add_test_subdirectory(generator_integration_tests)

omim_add_tool_subdirectory(generator_tool)
#omim_add_tool_subdirectory(complex_generator)
omim_add_tool_subdirectory(feature_segments_checker)
omim_add_tool_subdirectory(srtm_coverage_checker)
add_subdirectory(world_roads_builder)
add_subdirectory(address_parser)

=== libs/CMakeLists.txt ===
add_subdirectory(base)
add_subdirectory(coding)
add_subdirectory(descriptions)
add_subdirectory(drape)
add_subdirectory(drape_frontend)
add_subdirectory(editor)
add_subdirectory(ge0)
add_subdirectory(mwm_diff)
add_subdirectory(geometry)
add_subdirectory(indexer)
add_subdirectory(kml)
add_subdirectory(map)
add_subdirectory(cppjansson)
add_subdirectory(platform)
add_subdirectory(routing)
add_subdirectory(routing_common)
add_subdirectory(search)
add_subdirectory(shaders)
add_subdirectory(storage)
add_subdirectory(timezone)
add_subdirectory(tracking)
add_subdirectory(traffic)
add_subdirectory(transit)

=== qt/CMakeLists.txt ===
project(desktop)

QT6_ADD_RESOURCES(RES_SOURCES res/resources.qrc)

set(SRC
  about.cpp
  about.hpp
  bookmark_dialog.cpp
  bookmark_dialog.hpp
  build_style/build_common.cpp
  build_style/build_common.h
  build_style/build_drules.cpp
  build_style/build_drules.h
  build_style/build_phone_pack.cpp
  build_style/build_phone_pack.h
  build_style/build_skins.cpp
  build_style/build_skins.h
  build_style/build_statistics.cpp
  build_style/build_statistics.h
  build_style/build_style.cpp
  build_style/build_style.h
  build_style/run_tests.cpp
  build_style/run_tests.h
  create_feature_dialog.cpp
  create_feature_dialog.hpp
  draw_widget.cpp
  draw_widget.hpp
  editor_dialog.cpp
  editor_dialog.hpp
  html_processor.cpp
  html_processor.hpp
  info_dialog.cpp
  info_dialog.hpp
  main.cpp
  mainwindow.cpp
  mainwindow.hpp
  mwms_borders_selection.cpp
  mwms_borders_selection.hpp
  osm_auth_dialog.cpp
  osm_auth_dialog.hpp
  place_page_dialog_common.cpp
  place_page_dialog_common.hpp
  place_page_dialog_developer.cpp
  place_page_dialog_developer.hpp
  place_page_dialog_user.cpp
  place_page_dialog_user.hpp
  preferences_dialog.cpp
  preferences_dialog.hpp
  popup_menu_holder.cpp
  popup_menu_holder.hpp
  routing_settings_dialog.cpp
  routing_settings_dialog.hpp
  routing_turns_visualizer.cpp
  routing_turns_visualizer.hpp
  ruler.cpp
  ruler.hpp
  screenshoter.cpp
  screenshoter.hpp
  search_panel.cpp
  search_panel.hpp
  selection.hpp
  update_dialog.cpp
  update_dialog.hpp
)

omim_add_executable(${PROJECT_NAME} MACOSX_BUNDLE ${RES_SOURCES} ${SRC})

set_target_properties(${PROJECT_NAME} PROPERTIES AUTOMOC ON)

target_link_libraries(${PROJECT_NAME}
  PRIVATE
    generator  # For borders::LoadBorders
    qt_common
    map
    gflags::gflags
    location_service
)

if (BUILD_DESIGNER)
  target_link_libraries(${PROJECT_NAME} PRIVATE generator)
  set(BUNDLE_NAME "OMaps.Designer")
  set(BUNDLE_DISPLAY_NAME "Organic Maps Designer")
  set(BUNDLE_ICON designer.icns)
else()
  set(BUNDLE_NAME "OMaps")
  set(BUNDLE_DISPLAY_NAME "Organic Maps Desktop")
  set(BUNDLE_ICON mac.icns)
endif()

set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME ${BUNDLE_NAME})

set(BUNDLE_EXECUTABLE ${BUNDLE_NAME})

set(BUNDLE_FOLDER ${CMAKE_BINARY_DIR}/${BUNDLE_NAME}.app)
set(RESOURCES_FOLDER ${BUNDLE_FOLDER}/Contents/Resources)
set(DATA_DIR ${OMIM_ROOT}/data)

function(copy_resources)
  execute_process(COMMAND mkdir -p ${RESOURCES_FOLDER})
  foreach(file ${ARGN})
    execute_process(
      COMMAND cp -r ${DATA_DIR}/${file} ${RESOURCES_FOLDER}
    )
  endforeach()
endfunction()

copy_resources(
  countries-strings
  fonts
  symbols
  welcome.html

  categories.txt
  categories_cuisines.txt
  classificator.txt
  colors.txt
  copyright.html
  countries.txt
  drules_proto_default_light.bin
  drules_proto_default_dark.bin
  drules_proto_outdoors_light.bin
  drules_proto_outdoors_dark.bin
  drules_proto_vehicle_light.bin
  drules_proto_vehicle_dark.bin
  editor.config
  packed_polygons.bin
  patterns.txt
  transit_colors.txt
  types.txt
  World.mwm
  WorldCoasts.mwm
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/)
install(DIRECTORY ${OMIM_ROOT}/data DESTINATION ${CMAKE_INSTALL_PREFIX}/share/organicmaps/)

if (PLATFORM_LINUX)
  install(FILES ${OMIM_ROOT}/packaging/app.organicmaps.desktop.metainfo.xml DESTINATION ${CMAKE_INSTALL_PREFIX}/share/metainfo/)
  install(FILES ${OMIM_ROOT}/qt/res/linux/app.organicmaps.desktop.desktop DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)
  install(FILES ${OMIM_ROOT}/qt/res/logo.png DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/512x512/apps/ RENAME organicmaps.png)
endif()

if (NOT PLATFORM_LINUX)
  # On Linux, ICU data is loaded from the shared library.
  copy_resources(icudt78l.dat)
endif()

if (PLATFORM_MAC)
  if (BUILD_DESIGNER)
    execute_process(
        COMMAND cp ${PROJECT_SOURCE_DIR}/res/mac/designer.icns ${RESOURCES_FOLDER}
    )
  else ()
    execute_process(
        COMMAND cp ${PROJECT_SOURCE_DIR}/res/mac/mac.icns ${RESOURCES_FOLDER}
    )
  endif ()
endif()

if (PLATFORM_MAC)
  if (NOT APP_VERSION)
    set(BUNDLE_VERSION "UNKNOWN")
  else()
    set(BUNDLE_VERSION ${APP_VERSION})
  endif()

  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/res/mac/Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/generated/Info.plist)

  set_target_properties(${PROJECT_NAME}
    PROPERTIES
      OUTPUT_NAME ${BUNDLE_NAME}
      MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/generated/Info.plist
  )
endif()

if (PLATFORM_WIN)
  target_sources(${PROJECT_NAME} PRIVATE res/windows/windows.rc)
endif()

if (BUILD_DESIGNER)
  execute_process(
    COMMAND cp -rf ${OMIM_ROOT}/data/symbols/mdpi/light/ ${OMIM_ROOT}/data/symbols/mdpi/design/
    COMMAND cp -rf ${OMIM_ROOT}/data/symbols/hdpi/light/ ${OMIM_ROOT}/data/symbols/hdpi/design/
    COMMAND cp -rf ${OMIM_ROOT}/data/symbols/xhdpi/light/ ${OMIM_ROOT}/data/symbols/xhdpi/design/
    COMMAND cp -rf ${OMIM_ROOT}/data/symbols/xxhdpi/light/ ${OMIM_ROOT}/data/symbols/xxhdpi/design/
    COMMAND cp -rf ${OMIM_ROOT}/data/symbols/6plus/light/ ${OMIM_ROOT}/data/symbols/6plus/design/
    COMMAND cp -rf ${OMIM_ROOT}/data/symbols/xxxhdpi/light/ ${OMIM_ROOT}/data/symbols/xxxhdpi/design/
    COMMAND cp -f ${OMIM_ROOT}/data/drules_proto_default_light.bin ${OMIM_ROOT}/data/drules_proto_default_design.bin
    COMMAND cp -f ${OMIM_ROOT}/data/colors.txt ${OMIM_ROOT}/data/colors_design.txt
    COMMAND cp -f ${OMIM_ROOT}/data/patterns.txt ${OMIM_ROOT}/data/patterns_design.txt
  )

  copy_resources(
    colors_design.txt
    drules_proto_default_design.bin
    mapcss-dynamic.txt
    mapcss-mapping.csv
    patterns_design.txt
    symbols/mdpi/design
    symbols/hdpi/design
    symbols/xhdpi/design
    symbols/xxhdpi/design
    symbols/xxxhdpi/design
    symbols/6plus/design
  )

  execute_process(
    COMMAND cp ${OMIM_ROOT}/tools/python/recalculate_geom_index.py ${RESOURCES_FOLDER}
    COMMAND cp ${OMIM_ROOT}/tools/python/generate_styles_override.py ${RESOURCES_FOLDER}
    COMMAND cp -rf ${OMIM_ROOT}/tools/kothic ${RESOURCES_FOLDER}/kothic/
    COMMAND cp -f ${OMIM_ROOT}/tools/python/stylesheet/drules_info.py ${RESOURCES_FOLDER}/kothic/src/
    COMMAND cp -rf ${OMIM_ROOT}/tools/python/stylesheet/ ${RESOURCES_FOLDER}/kothic/src/
    COMMAND cp -f ${OMIM_ROOT}/3party/protobuf/protobuf-3.3.0-py2.7.egg ${RESOURCES_FOLDER}/kothic/
  )

  # Generate DMG
  install(DIRECTORY ${DATA_DIR}/styles DESTINATION .)
  set(BUNDLES
    ${CMAKE_BINARY_DIR}/generator_tool.app
    ${CMAKE_BINARY_DIR}/skin_generator_tool.app
    ${CMAKE_BINARY_DIR}/style_tests.app
  )
  install(CODE "
    foreach(BUNDLE ${BUNDLE_FOLDER} ${BUNDLES})
      execute_process(
        COMMAND \"${QT_PATH}/bin/macdeployqt\" \"\${BUNDLE}\"
      )
    endforeach()
    foreach(BUNDLE ${BUNDLES})
      execute_process(
        COMMAND cp -rf \"\${BUNDLE}\" \"${RESOURCES_FOLDER}\"
      )
    endforeach()
  ")
  install(TARGETS ${PROJECT_NAME} DESTINATION .)

  set(CPACK_GENERATOR DragNDrop)
  set(CPACK_DMG_FORMAT UDZO)
  set(CPACK_DMG_VOLUME_NAME ${BUNDLE_NAME})
  set(CPACK_PACKAGE_ICON ${PROJECT_SOURCE_DIR}/res/mac/designer.icns)
  include(CPack)
elseif (BUILD_STANDALONE)
  add_custom_command(TARGET desktop POST_BUILD
    COMMAND "${QT_PATH}/bin/macdeployqt" ${BUNDLE_FOLDER}
    COMMAND ${Python3_EXECUTABLE} "${OMIM_ROOT}/tools/macdeployqtfix/macdeployqtfix.py" -q -nl ${BUNDLE_FOLDER}/Contents/MacOS/${BUNDLE_NAME} ${QT_PATH}
    COMMAND echo "Fixing Qt dependencies finished."
    VERBATIM
    COMMENT "Fixing Qt dependencies for standalone desktop app"
  )
endif()

add_subdirectory(qt_common)

=== tools/CMakeLists.txt ===
add_subdirectory(openlr)
add_subdirectory(poly_borders)
add_subdirectory(track_analyzing)

omim_add_tool_subdirectory(mwm_viewer)
omim_add_tool_subdirectory(topography_generator)
omim_add_tool_subdirectory(track_generator)
if (NOT SKIP_QT_GUI)
  omim_add_tool_subdirectory(skin_generator)
endif()

=== 3party/libtess2/CMakeLists.txt ===
project(tess2)

include_directories(Include)

set(
  SRC
  Include/tesselator.h
  Source/bucketalloc.c
  Source/bucketalloc.h
  Source/dict.c
  Source/dict.h
  Source/geom.c
  Source/geom.h
  Source/mesh.c
  Source/mesh.h
  Source/priorityq.c
  Source/priorityq.h
  Source/sweep.c
  Source/sweep.h
  Source/tess.c
  Source/tess.h
)

add_library(${PROJECT_NAME} ${SRC})

=== 3party/open-location-code/CMakeLists.txt ===
project(openlocationcode)

include_directories(src ../../)

set(
  SRC
  codearea.cc
  codearea.h
  openlocationcode.cc
  openlocationcode.h
)

add_library(${PROJECT_NAME} ${SRC})

=== 3party/succinct/CMakeLists.txt ===
project(succinct)

set(SRC
  bit_vector.hpp
  bp_vector.cpp
  bp_vector.hpp
  broadword.hpp
  cartesian_tree.hpp
  darray.hpp
  darray64.hpp
  elias_fano_compressed_list.hpp
  elias_fano_list.hpp
  elias_fano.hpp
  forward_enumerator.hpp
  gamma_bit_vector.hpp
  gamma_vector.hpp
  intrinsics.hpp
  mappable_vector.hpp
  mapper.hpp
  nibble_vector.hpp
  rs_bit_vector.cpp
  rs_bit_vector.hpp
  tables.hpp
  topk_vector.hpp
  util.hpp
  vbyte.hpp
)

# Requires boost include.
omim_add_library(${PROJECT_NAME} ${SRC})

=== 3party/vulkan_wrapper/CMakeLists.txt ===
project(vulkan_wrapper)

set(SRC
  vulkan_wrapper.cpp
  vulkan_wrapper.h
)

add_library(${PROJECT_NAME} ${SRC})

if (WITH_SYSTEM_PROVIDED_3PARTY)
  find_package(VulkanHeaders REQUIRED)
  target_link_libraries(${PROJECT_NAME} Vulkan::Headers)
else()
  set(VulkanHeaders_INCLUDE_DIR ../Vulkan-Headers/include)
  target_include_directories(${PROJECT_NAME} PUBLIC ../Vulkan-Headers/include)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC .)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    $<$<BOOL:${PLATFORM_LINUX}>:VK_USE_PLATFORM_XLIB_KHR>
    $<$<BOOL:${PLATFORM_WIN}>:VK_USE_PLATFORM_WIN32_KHR>
    $<$<BOOL:${PLATFORM_ANDROID}>:VK_USE_PLATFORM_ANDROID_KHR>
)

# dlopen
target_link_libraries(${PROJECT_NAME} $<$<BOOL:CMAKE_DL_LIBS>:${CMAKE_DL_LIBS}>)

=== generator/address_parser/CMakeLists.txt ===
project(address_parser)

set(SRC
  processor.cpp
  processor.hpp
  tiger_parser.cpp
  tiger_parser.hpp
)

omim_add_library(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME} PUBLIC generator)


omim_add_executable(address_parser_tool parser_tool.cpp)
target_link_libraries(address_parser_tool
  PRIVATE
    ${PROJECT_NAME}
    gflags::gflags
)

omim_add_test_subdirectory(address_parser_tests)

=== generator/feature_segments_checker/CMakeLists.txt ===
project(feature_segments_checker)

set(SRC feature_segments_checker.cpp)

omim_add_executable(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
  PRIVATE
    generator
    gflags::gflags
)

## organicmaps 2026.01.26-11+ds

=== debian/changelog ===
organicmaps (2026.01.26-11+ds-4) unstable; urgency=medium

  * Build with RELEASE set

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 11 Feb 2026 11:14:08 +0100

organicmaps (2026.01.26-11+ds-3) unstable; urgency=medium

  * Fixed redundant assert (Closes: #1127397)
  * Removed thread checker that fails when searching in Download dialog
    (Closes: #1127396)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 09 Feb 2026 18:12:06 +0100

organicmaps (2026.01.26-11+ds-2) unstable; urgency=medium

  * Check if region's info contains triangles.

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 07 Feb 2026 17:40:15 +0100

organicmaps (2026.01.26-11+ds-1) unstable; urgency=medium

  * Use uscan v5
  * Update Files-Excluded in d/copyright
  * New upstream version 2026.01.26-11+ds
  * Update d/patches
  * Fix d/rules
  * Update d/clean
  * Install DATA_LICENSE.txt
  * Update d/copyright
  * Drop R³
  * Drop optional priority
  * Mark organicmaps-data Multi-Arch: foreign
  * Bump policy version (no changes)
  * Update build dependencies

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 06 Feb 2026 11:10:24 +0100

=== debian/control ===
Source: organicmaps
Section: x11
Maintainer: Federico Ceratto <federico@debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libagg2-dev,
 libboost-dev,
 libexpat1-dev,
 libfast-float-dev,
 libfastobj-dev,
 libflathashmap-dev,
 libfreetype-dev,
 libgflags-dev,
 libglaze-dev,
 libglm-dev,
 libgmock-dev,
 libharfbuzz-dev,
 libicu-dev,
 libjansson-dev,
 libkdtree++-dev,
 libminizip-dev,
 libprotobuf-dev,
 libpugixml-dev,
 libqt6svg6,
 libstb-dev,
 libutfcpp-dev,
 optipng,
 protobuf-compiler,
 python3-mapcss,
 python3-protobuf,
 qt6-base-dev,
 qt6-positioning-dev,
 qt6-svg-dev,
 curl <!nocheck>,
 xauth,
 xvfb,
Standards-Version: 4.7.3
Homepage: https://organicmaps.app/
Vcs-Browser: https://salsa.debian.org/debian/organicmaps
Vcs-Git: https://salsa.debian.org/debian/organicmaps.git
Description: offline maps with routing ability
 Organic Maps is a map application for travelers, tourists, hikers,
 and cyclists based on top of crowd-sourced OpenStreetMap data.
 It is privacy-focused and can be used without an Internet connection.
 It provides navigation for pedestrians, public transport, cycling
 and driving.

Package: organicmaps
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 organicmaps-data,
Description: ${source:Synopsis} (executable)
 ${source:Extended-Description}
 .
 This package contains the OMaps executable.

Package: organicmaps-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} (data)
 ${source:Extended-Description}
 .
 This package contains architecture independent data.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_CPPFLAGS_MAINT_APPEND = -DRELEASE

%:
	dh $@

execute_before_dh_auto_configure:
	tools/unix/generate_proto.sh
	tools/unix/generate_drules.sh

override_dh_auto_configure:
	dh_auto_configure -- -DWITH_SYSTEM_PROVIDED_3PARTY=ON

execute_after_dh_auto_build:
	HOME=/tmp obj-$(DEB_HOST_GNU_TYPE)/generator_tool -generate_packed_borders
	xvfb-run tools/unix/generate_symbols.sh
